import static java.lang.Math.*;
public class functorAtomForce extends Thread{
    world olWorld;
    int start,
        end,
        atomQty;
    atom atomSrc[],
         atomDest[];
    double deltaT;
         
    //worldFunc f = new worldFunc();
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorAtomForce(world _olWorld, atom [] atomLst, int _start, int _end, int _atomQty)
    {
        olWorld = _olWorld;
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
        atomQty = _atomQty;
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
            nuAtom = new atom(atomSrc[i]);
            //interatom forces
            for (int j=0; j<atomQty; j++)
                if (i!=j)
                {
                    vector link = v.sub(nuAtom.pos, atomSrc[j].pos);     // get direction vector
                    double distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                    double restlenght = nuAtom.radius + atomSrc[j].radius;     // get collision threshold
                    if (distCentersSQ == 0.0d)                                               // check if position overlap
                        nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
                    else if (distCentersSQ < restlenght*restlenght)                          // check if collide
                    {
                        nuAtom = a.addforce(nuAtom, a.repulseSQ(nuAtom, atomSrc[j], restlenght, distCentersSQ, 0.1,0.1));
                        //test fuse, those who dont have type0 and are the same type can fuse
//                        if (atomSrc[j].type != 0)
//                            if (nuAtom.type == atomSrc[j].type)
//                            {   
//                                double nudist = (nuAtom.radius+atomSrc[j].radius) * 1.9;
//                                nuAtom = a.linkWith(nuAtom, j, nudist);
//                            }

                    }
                }

            //spring forces
            nuAtom = a.springForceSQ(nuAtom,atomSrc);

            atomDest[i-start] = nuAtom;
        }
    }
}
